searchData={"items":[{"type":"module","title":"Mozart.BpmProcess","doc":"","ref":"Mozart.BpmProcess.html"},{"type":"macro","title":"Mozart.BpmProcess.case_i/2","doc":"","ref":"Mozart.BpmProcess.html#case_i/2"},{"type":"macro","title":"Mozart.BpmProcess.case_task/2","doc":"","ref":"Mozart.BpmProcess.html#case_task/2"},{"type":"macro","title":"Mozart.BpmProcess.defprocess/2","doc":"","ref":"Mozart.BpmProcess.html#defprocess/2"},{"type":"macro","title":"Mozart.BpmProcess.insert_new_task/1","doc":"","ref":"Mozart.BpmProcess.html#insert_new_task/1"},{"type":"macro","title":"Mozart.BpmProcess.parallel_task/2","doc":"","ref":"Mozart.BpmProcess.html#parallel_task/2"},{"type":"function","title":"Mozart.BpmProcess.parse_inputs/1","doc":"","ref":"Mozart.BpmProcess.html#parse_inputs/1"},{"type":"function","title":"Mozart.BpmProcess.parse_user_groups/1","doc":"","ref":"Mozart.BpmProcess.html#parse_user_groups/1"},{"type":"macro","title":"Mozart.BpmProcess.receive_task/2","doc":"","ref":"Mozart.BpmProcess.html#receive_task/2"},{"type":"macro","title":"Mozart.BpmProcess.route/1","doc":"","ref":"Mozart.BpmProcess.html#route/1"},{"type":"macro","title":"Mozart.BpmProcess.rule_task/2","doc":"","ref":"Mozart.BpmProcess.html#rule_task/2"},{"type":"macro","title":"Mozart.BpmProcess.send_task/2","doc":"","ref":"Mozart.BpmProcess.html#send_task/2"},{"type":"macro","title":"Mozart.BpmProcess.service_task/2","doc":"","ref":"Mozart.BpmProcess.html#service_task/2"},{"type":"function","title":"Mozart.BpmProcess.set_next_tasks/1","doc":"","ref":"Mozart.BpmProcess.html#set_next_tasks/1"},{"type":"macro","title":"Mozart.BpmProcess.subprocess_task/2","doc":"","ref":"Mozart.BpmProcess.html#subprocess_task/2"},{"type":"macro","title":"Mozart.BpmProcess.timer_task/2","doc":"","ref":"Mozart.BpmProcess.html#timer_task/2"},{"type":"macro","title":"Mozart.BpmProcess.user_task/2","doc":"","ref":"Mozart.BpmProcess.html#user_task/2"},{"type":"module","title":"Mozart.Data.ProcessModel","doc":"```\ndefstruct [:name, :tasks, :initial_task]\n```\n\nThis struct is used to create business process models. Once created, a process model\ncan be loaded into a `Mozart.ProcessEngine.html` and executed.\n\nAlso see Mozart.Task modules.\n\nExample:\n\n```\n%ProcessModel{\n      name: :user_task_process_model,\n      tasks: [\n        %User{\n          name: :user_task,\n          assigned_groups: [\"admin\"]\n        }\n      ],\n      initial_task: :user_task\n    }\n```","ref":"Mozart.Data.ProcessModel.html"},{"type":"module","title":"Mozart.Data.ProcessState","doc":"```\ndefstruct [\n    :uid,\n    :process_key,\n    :parent_pid,\n    :model_name,\n    :start_time,\n    :end_time,\n    :execute_duration,\n    open_tasks: %{},\n    completed_tasks: [],\n    data: %{},\n    complete: false\n  ]\nend\n```\n\nThis struct is used to represent the state of a `Mozart.ProcessEngine` execution.\n\nExample: (incrementally populated throughout process execution.)\n\n```\n%Mozart.Data.ProcessState{\n  uid: \"74146e68-088e-42b6-965e-20f4d7dbae16\",\n  process_key: \"74146e68-088e-42b6-965e-20f4d7123456\"\n  parent_pid: nil,\n  model_name: :call_external_service,\n  start_time: ~U[2024-05-27 15:22:01.847683Z],\n  end_time: ~U[2024-05-27 15:22:02.277273Z],\n  execute_duration: 429590,\n  open_tasks: %{},\n  completed_tasks: [\n    %{\n      data: %{},\n      function: #Function<0.23164178/1 in Mozart.ProcessModels.TestModels.call_exteral_services/0>,\n      name: :get_api_data,\n      type: :service,\n      next: nil,\n      __struct__: Mozart.Task.Service,\n      uid: \"e3326041-d203-46b2-8141-907f71421398\",\n      process_uid: \"74146e68-088e-42b6-965e-20f4d7dbae16\"\n    }\n  ],\n  data: %{\n    todo_data: %{\n      \"completed\" => false,\n      \"id\" => 1,\n      \"title\" => \"delectus aut autem\",\n      \"userId\" => 1\n    }\n  },\n  complete: true\n}\n```","ref":"Mozart.Data.ProcessState.html"},{"type":"module","title":"Mozart.Event.TaskExit","doc":"","ref":"Mozart.Event.TaskExit.html"},{"type":"module","title":"Mozart.ProcessEngine","doc":"A ProcessEngine is dynamically spawned for the purpose of executing a process model defined by **defprocess**.","ref":"Mozart.ProcessEngine.html"},{"type":"function","title":"Mozart.ProcessEngine.complete_on_task_exit_event/1","doc":"Complete subprocess due to a TaskExit event","ref":"Mozart.ProcessEngine.html#complete_on_task_exit_event/1"},{"type":"function","title":"Mozart.ProcessEngine.execute/1","doc":"Used to complete any \"complete-able\" open tasks. Task execution frequently spawns new\nopen tasks. Execute will continue to as long as there are \"complete-able\" open tasks.","ref":"Mozart.ProcessEngine.html#execute/1"},{"type":"function","title":"Mozart.ProcessEngine.get_open_tasks/1","doc":"Gets the open tasks of the given process engine","ref":"Mozart.ProcessEngine.html#get_open_tasks/1"},{"type":"function","title":"Mozart.ProcessEngine.get_state/1","doc":"","ref":"Mozart.ProcessEngine.html#get_state/1"},{"type":"function","title":"Mozart.ProcessEngine.start_process/4","doc":"Use this function to create a ProcessEngine instance initialized with the\nname of the process model to be executed and any initialization data. The\nengine will start executing tasks with the execute/1 function is called.","ref":"Mozart.ProcessEngine.html#start_process/4"},{"type":"module","title":"Mozart.ProcessService","doc":"This modeule provides services required by individual `Mozart.ProcessEngine` instances. Currently,\nit has no user level functions. Subject to change.","ref":"Mozart.ProcessService.html"},{"type":"function","title":"Mozart.ProcessService.get_active_process_groups/4","doc":"","ref":"Mozart.ProcessService.html#get_active_process_groups/4"},{"type":"function","title":"Mozart.ProcessService.get_completed_process/1","doc":"Returns the state of the completed process corresponding to the process engine's uid","ref":"Mozart.ProcessService.html#get_completed_process/1"},{"type":"function","title":"Mozart.ProcessService.get_completed_process_data/1","doc":"Returns the data accumulated by the completed process","ref":"Mozart.ProcessService.html#get_completed_process_data/1"},{"type":"function","title":"Mozart.ProcessService.get_completed_process_db/0","doc":"Get process model db","ref":"Mozart.ProcessService.html#get_completed_process_db/0"},{"type":"function","title":"Mozart.ProcessService.get_completed_processes_local/1","doc":"","ref":"Mozart.ProcessService.html#get_completed_processes_local/1"},{"type":"function","title":"Mozart.ProcessService.get_process_model/1","doc":"Retrieves a process model by name.","ref":"Mozart.ProcessService.html#get_process_model/1"},{"type":"function","title":"Mozart.ProcessService.get_process_model_db/0","doc":"Get process model db","ref":"Mozart.ProcessService.html#get_process_model_db/0"},{"type":"function","title":"Mozart.ProcessService.get_process_models/0","doc":"","ref":"Mozart.ProcessService.html#get_process_models/0"},{"type":"function","title":"Mozart.ProcessService.get_process_pid_from_uid/1","doc":"Get a process pid from it UID","ref":"Mozart.ProcessService.html#get_process_pid_from_uid/1"},{"type":"function","title":"Mozart.ProcessService.get_processes_for_process_key/1","doc":"","ref":"Mozart.ProcessService.html#get_processes_for_process_key/1"},{"type":"function","title":"Mozart.ProcessService.get_state/0","doc":"","ref":"Mozart.ProcessService.html#get_state/0"},{"type":"function","title":"Mozart.ProcessService.get_user_task/1","doc":"Get a user task by uid","ref":"Mozart.ProcessService.html#get_user_task/1"},{"type":"function","title":"Mozart.ProcessService.get_user_task_db/0","doc":"Get process model db","ref":"Mozart.ProcessService.html#get_user_task_db/0"},{"type":"function","title":"Mozart.ProcessService.get_user_tasks_for_groups/1","doc":"Returns the user tasks that can be completed by users belonging to one of the input groups.","ref":"Mozart.ProcessService.html#get_user_tasks_for_groups/1"},{"type":"function","title":"Mozart.ProcessService.get_user_tasks_for_user/1","doc":"Get user tasks eligible for assignment and completion by the specified user.","ref":"Mozart.ProcessService.html#get_user_tasks_for_user/1"},{"type":"function","title":"Mozart.ProcessService.load_process_model/1","doc":"Loads a single process model in the repository.","ref":"Mozart.ProcessService.html#load_process_model/1"},{"type":"function","title":"Mozart.ProcessService.load_process_models/1","doc":"Loads a list of process model into the state of the\nProcessService.","ref":"Mozart.ProcessService.html#load_process_models/1"},{"type":"function","title":"Mozart.ProcessService.update_for_completed_process/1","doc":"","ref":"Mozart.ProcessService.html#update_for_completed_process/1"},{"type":"module","title":"Mozart.UserService","doc":"Provides client applications with functionality related to users and groups. Much more\nfunctionality to come.","ref":"Mozart.UserService.html"},{"type":"function","title":"Mozart.UserService.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mozart.UserService.html#child_spec/1"},{"type":"function","title":"Mozart.UserService.get_assigned_groups/1","doc":"Returns the groups that a user is a member of.","ref":"Mozart.UserService.html#get_assigned_groups/1"},{"type":"function","title":"Mozart.UserService.get_user/1","doc":"Given a user id, return detailed user info.","ref":"Mozart.UserService.html#get_user/1"},{"type":"function","title":"Mozart.UserService.insert_user/1","doc":"Adds a new user to the system.","ref":"Mozart.UserService.html#insert_user/1"},{"type":"extras","title":"Introduction to BPM","doc":"# Introduction to BPM\n\nThe next several sections provide an introduction to to ***Business Process Management***.","ref":"intro_bpm.html"},{"type":"extras","title":"What is a Business Process? - Introduction to BPM","doc":"Companies large and small have business processes that they regularly execute. Let's just call them \"processes\" for brevity's sake. Insurance companies have processes to process a claim. Banks have processes to approve loans. The government have processes to award contracts. \n\nBusiness processes have the following charateristics:\n\n* A business process is comprised of some number of individual tasks. \n* Tasks are performed in an order prescribed by network of task connections.\n* Processes can branch to multiple alternative sets of tasks depending on the state of the process.\n* Processes can branch to multiple parallel paths as well.\n* There are multiple kinds of tasks. Some tasks are performed by users. Some tasks are performed by calling services. There are many other kinds of tasks as well.\n* Processes store data to be used by tasks to perform their functions.\n* Processes allow tasks to add data for use by downstream tasks.","ref":"intro_bpm.html#what-is-a-business-process"},{"type":"extras","title":"What is Business Process Management (BPM)? - Introduction to BPM","doc":"Business Process Management (BPM) is the organized and directed activity of a company to control, monitor and improve the quality of their business processes. They do this with the aid of a BPM platform made available by dozens of commercial vendors.\n\nBPM platforms provide the following functions:\n\n* Provide developers with the ability of define and store process models.\n* Provide developers with the ability have certain tasks completed by making service calls.\n* Provide users and administrators with the ability to start process instances.\n* Provide users with the ability to assign user tasks to specified users.\n* Prvide users with the ability to assign user tasks to members of a specified user group.\n\nThe goals of Business Process Management are:\n\n* Better Process Reliablibility\n* Faster Process Execugtion\n* Reduced Training Requirements\n* Incremental Process Improvement\n* Provide Process Metrics\n* Cost Savings","ref":"intro_bpm.html#what-is-business-process-management-bpm"},{"type":"extras","title":"When is BPM Applicable - Introduction to BPM","doc":"This is difficult to answer exactly, but BPM may be applicable when:\n\n* Processes are performed on a regular basis.\n* Successful process execution is crucial to the business.\n* Current processes are error prone.\n* The speed of process completion is very important.\n* Processes are well defined.\n* Multiple business groups and/or people participate in process execution.","ref":"intro_bpm.html#when-is-bpm-applicable"},{"type":"extras","title":"Introduction to Mozart","doc":"# Introduction to Mozart","ref":"app_overview.html"},{"type":"extras","title":"Process Models - Introduction to Mozart","doc":"The primary concept of *Mozart* is the **Process Model**. A *process model* is an executable representation of a business process. *Process models* are implemented using a collection of macros that together comprise a **Domain Specific Language (DSL)** used for the purpose of creating BPM Applications.\n\nIf you are a developer working for a bank, you might be asked to develop a process model for handling a customer loan application, which might look like this:\n\n```elixir\n  defprocess \"process loan application\" do\n    user_task(\"record and check loan application\",  groups: \"customer service\")\n    user_task(\"determine loan acceptance\",          groups: \"underwriting\")\n    user_task(\"inform customer of result\",          groups: \"customer service\")\n  end\n```","ref":"app_overview.html#process-models"},{"type":"extras","title":"Process Model Tasks - Introduction to Mozart","doc":"As indicated in the example above, a *process model* is composed of a collection of **tasks**. Each task represents some work that needs to be completed. To **complete** a task means to perform the work required of the task.\n\nMozart provides arounds a dozen different types of *tasks*. Tasks are defined using macros in the Mozart DSL.\n\nThe task types currently supported are:\n\n| Task Type               |  Description |\n|-----|-----|\n| user_task               | Performed by a user |\n| service_task            | Performed by calling a service. |\n| subprocess_task         | Performed by calling a subprocess. |\n| timer_task              | Waits for expiration of a timer. |\n| receive_task            | Waits for a subscribed PubSub event. |\n| send_task               | Sends a PubSub event. |\n| rule_task               | Performed by evaluating a set of rules represented in a table. |\n| case_task               | Selects one of many process paths. |\n| parallel_task           | Initiates two or more parallel process paths. |","ref":"app_overview.html#process-model-tasks"},{"type":"extras","title":"Process Application - Introduction to Mozart","doc":"A **process application** is simply a set of related **process models** grouped together in an Elixir module. There is an [example process application](https://github.com/CharlesIrvineKC/mozart/blob/main/test/support/home_loan_app.ex) in the Mozart GitHub repository.\n\n*Process applications* must **use Mozart.BpmProcess** to gain access to the Mozart DSL:\n\n```elixir\ndefmodule MyProcessApplication do\n  use Mozart.BpmProcess\n  .... multiple process model definitions\nend\n```","ref":"app_overview.html#process-application"},{"type":"extras","title":"Process Engine - Introduction to Mozart","doc":"We have said that a Mozart process model is **executable**. What does that mean? Each process model is loaded into an instance of a Mozart process engine, implemented by the GenServer `Mozart.ProcessEngine`. After loading the process model, a command is invoked to to begin executing the process model. Here is a corresponding code snippet:\n\n```elixir\n{:ok, ppid, uid, _process_key} = ProcessEngine.start_process(\"one service task process\", %{x: 3})\nProcessEngine.execute(ppid)\n```\n\nFirst, a *process engine* is spawned by calling **ProcessEngine.start_process/2**. The first parameter specifies the top level *process model* to be executed. As you will see later on, a hierarchy of process instances can be spawned to complete the top level process model. The second argument is data used to initiate process execution. \n\nThe first argument returned is the Elixir *process identifier* of the Elixir GenServer. The secord value returned is a unique identifier of the process execution. This will be useful beyond the lifetime of the Elixir process. Finally, the third value returned is another unique identifier corresponding to the hierarchy of processes spawned to complete the top level process model.","ref":"app_overview.html#process-engine"},{"type":"extras","title":"Process Service - Introduction to Mozart","doc":"(Needs an update for more process services functions) When a process model has been developed, it is stored in a process model repository for later use. The repository is implemented by `Mozart.ProcessService`. When system users are ready to execute a process model, they retrieve it from the repository and use it to start a process engine execution.","ref":"app_overview.html#process-service"},{"type":"extras","title":"Processes Model Execution - Introduction to Mozart","doc":"Earlier we said that the job of the process engine is to drive a process model execution to completion. Let's discuss what that means.","ref":"app_overview.html#processes-model-execution"},{"type":"extras","title":"Completing Tasks - Introduction to Mozart","doc":"Every process model must specify an **initial task**. This will be the first task opened for completion. Completion of the initial task will often, though not always, trigger the opening of additional tasks. Every task that completes will potentially trigger the opening of additional tasks. At least one task in a process model will not trigger any downstream tasks. Eventually, a process model will stop generating new open tasks and it's process engine will terminate.\n\nSo, completing the execution of a process model equates to repeatedly opening and completing tasks until the process as a whole is complete.","ref":"app_overview.html#completing-tasks"},{"type":"extras","title":"Accumulating Data - Introduction to Mozart","doc":"Almost every task that is opened will need some data to complete. Further, when a task completes, it will introduce some new data for downstream tasks to use. Thus, to a great extent, completing a processes equates to generating a store of information.\n\nAll of the data generated by task completion is stored in the **data** property of `Mozart.ProcessEngine`.","ref":"app_overview.html#accumulating-data"},{"type":"extras","title":"Producing Side Effects - Introduction to Mozart","doc":"To be useful, almost all process model executions will produce some side effects. Take the process of processing a bank loan application for example. What are the possible side effects?\n\n* Sending a notice that the loan is approved or declined.\n* Depositing money in the customers account.\n* Setting up the loan in the banks backend system.","ref":"app_overview.html#producing-side-effects"},{"type":"extras","title":"Conclusion - Introduction to Mozart","doc":"Hopefully, the mechanics of Business Process Managment is now much clearer. In the newxt section, we will use Mozart to execute business processes.","ref":"app_overview.html#conclusion"},{"type":"extras","title":"First Process Execution","doc":"# First Process Execution\n\nNow we will put together what we've lerned so far to execute a process model.","ref":"first_process_execution.html"},{"type":"extras","title":"To Follow Along.. - First Process Execution","doc":"To follow along create a new Elxir **mix** project and then add Mozart as a dependency in your **mix.exs** project file. Your dependency should look like this:\n\n```elixir\n  defp deps do\n    [\n      {:mozart, \"~> 0.2\"}\n    ]\n  end\n```","ref":"first_process_execution.html#to-follow-along"},{"type":"extras","title":"Create BPM Application - First Process Execution","doc":"First you need to create a BPM application module. In it you will specify your process models and any needed supported functions. Add the following file to your project.\n\n```elixir\ndefmodule MyBpmApplication do\n  use Mozart.BpmProcess\n\n  # Your process models and supporting functions will go here.\n\nend\n```","ref":"first_process_execution.html#create-bpm-application"},{"type":"extras","title":"Construct the Process Model - First Process Execution","doc":"First, let us construct a simple process model that will have a single service task. The service task will simply return the sum of two input properties. Update your BPM application module as follows:\n\n```elixir\ndefmodule MyBpmApplication do\n  use Mozart.BpmProcess\n\n  def sum(data) do\n    %{sum: data.x + data.y}\n  end\n\n  defprocess \"add x and y process\" do\n    service_task(\"add x and y task\", function: &MyBpmApplication.sum/1, inputs: \"x,y\")\n  end\n\nend\n```","ref":"first_process_execution.html#construct-the-process-model"},{"type":"extras","title":"Load the Process Model into repository - First Process Execution","doc":"Now let's load this process model into the process model repository, which is implemented by (`Mozart.ProcessService`). First, start an iex session with **iex -S mix** and paste a couple of aliases into your iex session:\n\n```elixir\nalias Mozart.ProcessEngine, as: PE\nalias Mozart.ProcessService, as: PS\n\n```\n\nNow we are ready to load our process model into the repository. Copy the following into your iex session:\n\n```elixir\nPS.load_process_models(MyBpmApplication.get_processes())\n\n```\n\nYou should see:\n\n````\niex [15:06 :: 3] > PS.load_process_models(MyBpmApplication.get_processes())\n{:ok, [\"add x and y process\"]}\n````\n\nThe function **MyBpmApplication.get_processes/1** was created for you automatically when you inserted **use Mozart.BpmProcess** into your module definition.","ref":"first_process_execution.html#load-the-process-model-into-repository"},{"type":"extras","title":"Start a Process Engine and Execute the Process Model - First Process Execution","doc":"Now let us start a process engine, initializing it with our process model and some data. Then we call the function that will invoke process execution. Copy the following into your iex session:\n\n```elixir\n{:ok, ppid, uid, _key} = PE.start_process(\"add x and y process\", %{x: 1, y: 1})\n\n```\n\nYou should now see something like:\n\n```\n10:04:26.242 [info] Start process instance [add x and y process][a57d93d4-fc97-4a3c-89f6-989c088c96a7]\n{:ok, #PID<0.457.0>, \"a57d93d4-fc97-4a3c-89f6-989c088c96a7\", \"d41dc645-2417-4778-bb18-fccf2e6e44f6\"}\n```\n\nWe started a process instance using `Mozart.ProcessEngin.start_process/2`. We passed it the name of the process model to be executed and some initial data required for process execution. The function call returned a tuple with three values: \n\n* The **pid** of the resulting process engine.\n* The **uid** of the process instance. Every process execution will be given a unique identifier. You will see how this is used going forward.\n* Finally, a **process_key** is returned. Process models are hierarchial, meaning they can be composed of multiple, nested subprocesses. The top level business process and all of its subprocesses will share the same *process_key*. Here, were aren't going to be using the *process key*, but we will in subsequent examples.\n\nAfter creating the process engine instance, we then call `Mozart.ProcessEngine.execute/1` which causes the process engine to start completing any tasks that are ready to be completed. Let's do that now:\n\n```\nPE.execute(ppid)\n\n```\n\nAfter calling the *ProcessEngine.execute* function, you should see something like:\n\n```elixir\niex [08:50 :: 23] > PE.execute(ppid)\n:ok\n10:02:40.292 [info] New service task instance [add x and y task][ddd36158-7837-4c5a-b0be-66a02f304d27]\n10:02:40.292 [info] Complete service task [add x and y task[ddd36158-7837-4c5a-b0be-66a02f304d27]\n10:02:40.292 [info] Process complete [add x and y process][a1d4525d-96cb-4da1-9a82-d20bab4afa89]\n```\n\nThe logs show that:\n\n1. A new service task was opened.\n1. The service task completed.\n1. And finally the process engine completed executing the process model.","ref":"first_process_execution.html#start-a-process-engine-and-execute-the-process-model"},{"type":"extras","title":"Verify the Results - First Process Execution","doc":"Let's verify the results of our process model execution by calling **ProcessService.get_completed_process_data/1**. Copy the following into your iex session:\n\n```elixir\nPS.get_completed_process_data(uid)\n\n```\n\nand you should see:\n\n```elixir\niex [08:50 :: 26] > PS.get_completed_process_data(uid)\n%{sum: 2, y: 1, x: 1}\n```\n\nWe see that a **sum** property was added to process data whose value is the sume of the properties **x** and **y**..","ref":"first_process_execution.html#verify-the-results"},{"type":"extras","title":"Mozart Task Types","doc":"# Mozart Task Types","ref":"task_types.html"},{"type":"extras","title":"Service Task - Mozart Task Types","doc":"A **Service Task** performs its work by calling an Elixir function. This function could perform a computation, call an external JSON service, retrieve data from a database, etc.\n\nA service task has two unique fields: **function** and **inputs**.\n\n* The **function** field specifies the function that the service task should apply for the purpose of returning output data into the process state.\n* The **inputs** field is used to select which process data fields are passed to the task's function. If no value is supplied for this field, the entire process data is passed.","ref":"task_types.html#service-task"},{"type":"extras","title":"Service Task example - Mozart Task Types","doc":"If you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session\n\n```\n\n```\n\nNow define a process model with a single service task and assign it to a variable:\n\n```\n\n\n```\n\nWe have specified that state data properties **:x** and **:y** should be available to the task's function. \n\nThe task function will take the sum of **x** and **y** and assign the result to a new the new property **sum**.\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.load_process_model(model)\ndata = %{x: 1, y: 1}\n{:ok, ppid, uid, _process_key} = PE.start_process(\"process name\", data)\nPE.execute(ppid)\n\n```\n\nNow, to view the state of the completed process, paste the following into your iex session:\n\n```\nPS.get_completed_process(uid)\n\n```\n\nand should see something like this:\n\n```\n```\n\nWe see that the new property **sum** has been added to the state of the completed process.","ref":"task_types.html#service-task-example"},{"type":"extras","title":"User Task - Mozart Task Types","doc":"A **User Task** works by having a user complete some required task. This often takes the form of a user using a GUI to examine a subset of process data and then supplying additional data. \n\n**Important Note**: Users interact with a BPM platfrom such as Mozart by way of user application of some kind. The user application will allow the user to find tasks which may be assigned to him. Once the user accepts responsibility for a task, the application will then provide a user interface appropriate for accomplishing the given task. \n\nA user task has two unique fields: **:assigned_groups** and **:inputs**.\n\n* The **:assigned_groups** field specifies the user groups that are elibigle to complete the task. \n* The **:inputs** field is used to select which process data fields are passed to the user that will compleete the task. If no value is supplied for this field, the entire process data is passed.","ref":"task_types.html#user-task"},{"type":"extras","title":"User Task example - Mozart Task Types","doc":"If you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nNow we define a process model with a single service task and assign it to a variable:\n\n```\n\n```\n\nWe have specified that state data properties **:x** and **:y** should be available to the user that performs the task.\n\nThe user will compute the sum of **x** and **y** and assign the result to a new the new property **sum**.\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.clear_user_tasks()\nPS.load_process_model(model)\ndata = %{x: 1, y: 1}\n{:ok, ppid, uid, _process_key} = PE.start_process(:user_task_process_model, data)\nPE.execute(ppid)\n\n```\n\nAt this point, a user task has been opened and is available for a user to claim and complete. Now we need to find a user task that can be claimed by persons in specified groups. We can do that like this:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"admin\"])\n\n```\n\nwhich gives this result:\n\n```\n\n```\n\nNow, pulling the task uid from the results above, we can complete the user task like this:\n\n```\nPE.complete_user_task(ppid,  user_task.uid, %{sum: 2})\n\n```\n\nwhich will produce a result like this:\n\n```\n\n```\n\nDon't be concerned regarding the **shutdown** notice. It is normal. It simply means tht the process engine shutdown becuase the process had finished.\n\nNow we can verify that the process has completed and shows the expected value for process data:\n\n```\nPS.get_completed_process(uid)\n\n```\n\nand should see something like this:\n\n```\n\n```\n\nWe see that the new property **sum** has been added to the state of the completed process.","ref":"task_types.html#user-task-example"},{"type":"extras","title":"Rule Task - Mozart Task Types","doc":"A **Rule Task** performs its work by evaluating a rule table using process data. \n\nRule tasks use [Tablex](https://hexdocs.pm/tablex/0.3.1/readme.html), an incredibly useful Elixir library for evaluating [decision tables](https://en.wikipedia.org/wiki/Decision_table).\n\nA rule task has two unique fields: **:decision_args** and **:rule_table**.\n\n* The **:inputs** field specifies the state data fields used to evaluate the rule table.\n* The **:rule_table** field holds the Tablex table definition.","ref":"task_types.html#rule-task"},{"type":"extras","title":"Rule Task example - Mozart Task Types","doc":"If you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nNow define a process model with a single service task and assign it to a variable:\n\n```\n\n\n```\n\nWe have specified that state data property **:income** should be available as an input field to the rule table.\n\nThe **:rule_table** property holds the Tablex table to be evaluated.\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.load_process_model(model)\ndata = %{income: 3000}\n{:ok, ppid, uid, _process_key} = PE.start_process(:loan_approval, data)\nPE.execute(ppid)\n\n```\n\nNow, to view the state of the completed process, paste the following into your iex session:\n\n```\nPS.get_completed_process(uid)\n\n```\n\nand should see something like this:\n\n```\n\n```\n\nWe see that the new property **status** with a value of **declined** has been added to the state of the completed process.","ref":"task_types.html#rule-task-example"},{"type":"extras","title":"Parallel Task - Mozart Task Types","doc":"A parallel task is used to create multiple concurrent process execution paths. It does this by specifying multipple next tasks in its **multi_next** field.\n\nIf you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nNow define a process model with a parallel task and two user tasks. When the parallel task completes, the two user tasks should be opened in parallel.\n\n```\n\n\n```\n\nWe specify that state data properties **:user_task_1_input** and **:user_task_2_input** will passed to **:user_task_1** and **:user_task_2**, respectively. However, in this example we aren't going to actually complete the tasks. Hence, the property values won't actually be used.\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.load_process_model(model)\ndata = %{user_task_1_input: :input_1, user_task_2_input: :input_2}\n{:ok, ppid, uid, _process_key} = PE.start_process(:parallel_process_model, data)\nPE.execute(ppid)\n\n```\n\nNow, to view the state of the not yet complete process, paste the following into your iex session:\n\n```\nPE.get_state(ppid)\n\n```\n\nand should see something like this:\n\n```\n\n\n```\n\nWe see that parallel task **:parallel_user_tasks** has been completed. We also see our two user tasks have been opened in parallel, but have not yet been completed.","ref":"task_types.html#parallel-task"},{"type":"extras","title":"Subprocess Task - Mozart Task Types","doc":"A subprocess task performs its work by starting a subprocess instance as specified in its **sub_process** field.\n\nIf you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session:\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nNow we need two process models. The first process model will call a subprocess task, wait for its completion, and then call a service task. The second process model will be called as a subprocess of the first process model.\n\n```\n\n\n```\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.clear_state()\nPS.load_process_models(models)\ndata = %{value: 1}\n{:ok, ppid, uid, _process_key} = PE.start_process(:call_process_model, data)\nPE.execute(ppid)\n\n```\n\nAt this point, both the processess should have completed.\n\n```\nPS.get_completed_processes()\n\n```\n\nand should see something like this:\n\n```\n\n```\n\nWe see that two processes have completed. The process named **:call_process_model** is the top level process, and the named **:service_subprocess_model** is the subprocess. As expected, the top level process state shows two completed tasks and the subprocess state shows one completed task.","ref":"task_types.html#subprocess-task"},{"type":"extras","title":"Timer Task - Mozart Task Types","doc":"A **timer task** performs its work by delaying a process execution path by the duration specified in its **timer_duration** field.\n\nIf you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session:\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nNow we need two process models. The first process model will call a subprocess task, wait for its completion, and then call a service task. The second process model will be called as a subprocess of the first process model.\n\n```\n\n```\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.clear_state()\nPS.load_process_model(model)\ndata = %{}\n{:ok, ppid, uid, _process_key} = PE.start_process(:call_timer_task, data)\nPE.execute(ppid)\n\n```\n\nThe process should take about 5 seconds to complete. Watch for logging to report **process complete**. After that, invoke the following:\n\n```\nPS.get_completed_processes()\n\n```\n\nand should see something like this:\n\n```\n\n\n```\n\nNotice in the above that **execution_duration** is 5006433 microseconds, i.e. just a little over 5 seconds.","ref":"task_types.html#timer-task"},{"type":"extras","title":"Join Task - Mozart Task Types","doc":"The **join task** is used to sychronize any number of parallel execution paths. The **inputs** field holds a list of task names that must finish before the join task can be completed.\n\n\nIf you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session:\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nThe process model below has a parallel task that spawns tasks **:foo** and **:bar** in parallel.\n\n```\n\n\n```\n\nNow paste the following into your iex session to execute your process model:\n\n```\nPS.clear_state()\nPS.load_process_model(model)\ndata = %{}\n{:ok, ppid, uid, _process_key} = PE.start_process(:parallel_process_model, data)\nPE.execute(ppid)\n\n```\n\nDue to the presense of the timer task, the process should take about 10 seconds to complete. Watch for logging to report **process complete**. After that, invoke the following:\n\n```\nPS.get_completed_processes()\n\n```\n\nand should see something like this:\n\n```\n\n\n```\n\nNotice in the above that **execution_duration** is 10008138 microseconds, i.e. just a little over 10 seconds.","ref":"task_types.html#join-task"},{"type":"extras","title":"Send and Receive Tasks - Mozart Task Types","doc":"In this section we will demo both the **send** and **receive** tasks since they will normally be used together.\n\nThe **receive task** waits until a message has been received from a **send task** The send and receive tasks can reside in either the same of different process instances.\n\n\nIf you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session:\n\n```\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n\n```\n\nThe process models below contain one receiving process and one sending process.\n\n```\n\n\n```\n\nNow paste the following into your iex session to execute, first, the receive process, and then the send process instance. We insert a 5 second delay between the two processes.\n\n```\nPS.clear_state()\nPS.load_process_models(models)\ndata = %{}\n\n{:ok, r_ppid, r_uid, _process_key} = PE.start_process(:process_with_receive_task, data)\nPE.execute(r_ppid)\nProcess.sleep(5000)\n\n{:ok, s_ppid, s_uid, _process_key} = PE.start_process(:process_with_single_send_task, data)\nPE.execute(s_ppid)\n\n```\n\nDue to the presense of the timer task, the process should take about 10 seconds to complete. Watch for logging to report **process complete**. After that, invoke the following:\n\n```\nPS.get_completed_processes()\n\n```\n\nand should see something like this:\n\n```\n[\n\n\n```\n\nNotice in the above that **execution_duration** for the receive process is 5007144 microseconds, i.e. just a little over the 5 second process sleep pause.","ref":"task_types.html#send-and-receive-tasks"},{"type":"extras","title":"Home Loan Example","doc":"# Home Loan Example\n\nIn this guide we will construct and execute a somewhat more complex process model than we have dealt with thus far. We will mainly use **user tasks** because they allow use to easily control of the process execution path during process exploration.\n\nWe will create a process model applying for a home loan from a bank. It will be highly simplified compared to the actual process used by lending institutions, but complicated enough for our purposes here.\n\nHere is a summary of the loan approval process:\n\n1. Get pre-approval from the bank for a loan. They will require a credit score, yearly income and the extent of the applicant's indebtedness.\n1. After the applicant secures a contract on a house, he will fill out a complete loan application. Part of that will be the purchase price of the house.\n1. Now the bank will process the applicant's loan application. This is to ensure that everything is in order and they have everything that they need.\n1. After the loan has been processed, it will go to the underwriting department to determine whether the loan will be approved or not.\n1. Finally, after the loan is approced, the bank will notify the applicant that the loan is approved.\n\nIf you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session\n\n```\n  alias Mozart.ProcessService, as: PS\n  alias Mozart.ProcessEngine, as: PE\n  alias Mozart.Data.ProcessModel\n  alias Mozart.Task.User\n  alias Mozart.Task.Case\n\n```\n\nThe following is our loan processing process model. At this point, you might try to map the process model to the summary of the process given above.\n\nWhen you are ready, paste the process model into your iex session:\n\n```\nmodel = \n    %ProcessModel{\n      name: :home_loan_process,\n      tasks: [\n        %User{\n          name: :perform_pre_approval,\n          inputs: [:credit_score, :income, :debt_amount],\n          assigned_groups: [\"credit\"],\n          next: :route_on_pre_approval_completion\n        },\n        %Case{\n          name: :route_on_pre_approval_completion,\n          cases: [\n            %{\n              expression: fn data -> data.pre_approval == true end,\n              next: :receive_mortgage_application\n            },\n            %{\n              expression: fn data -> data.pre_approval == false end,\n              next: :communicate_loan_denied\n            }\n          ]\n        },\n        %User{\n          name: :receive_mortgage_application,\n          inputs: [:credit_score, :income, :debt_amount],\n          assigned_groups: [\"credit\"],\n          next: :process_loan\n        },\n        %User{\n          name: :process_loan,\n          inputs: [:purchase_price, :credit_score, :income, :debt_amount],\n          assigned_groups: [\"credit\"],\n          next: :process_loan_outcome\n        },\n        %Case{\n          name: :process_loan_outcome,\n          cases: [\n            %{\n              expression: fn data -> data.loan_verified == true end,\n              next: :perform_underwriting\n            },\n            %{\n              expression: fn data -> data.loan_verified == false end,\n              next: :communicate_loan_denied\n            }\n          ]\n        },\n        %User{\n          name: :perform_underwriting,\n          inputs: [:purchase_price, :credit_score, :income, :debt_amount, :loan_verified],\n          assigned_groups: [\"underwriting\"],\n          next: :route_from_underwriting\n        },\n        %Case{\n          name: :route_from_underwriting,\n          cases: [\n            %{\n              expression: fn data -> data.loan_approved == true end,\n              next: :communicate_approval\n            },\n            %{\n              expression: fn data -> data.loan_approved == false end,\n              next: :communicate_loan_denied\n\n            }\n          ]\n        },\n        %User{\n          name: :communicate_approval,\n          inputs: [:loan_approved],\n          assigned_groups: [\"credit\"]\n        },\n        %User{\n          name: :communicate_loan_denied,\n          inputs: [:loan_approved],\n          assigned_groups: [\"credit\"]\n        },\n      ],\n      initial_task: :perform_pre_approval\n      }\n\n```\n\nNow let's start executing this process. Paste the following into your iex session:\n\n```\nPS.clear_state()\nPS.load_process_model(model)\ndata = %{credit_score: 700, income: 100_000, debt_amount: 20_000}\n{:ok, ppid, _uid, _process_key} = PE.start_process(:home_loan_process, data)\nPE.execute(ppid)\n\n```\n\nAt this point, the user task to perform pre-approval should have been opened:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"credit\"])\n\n```\n\nwhich returns:\n\n```\niex [11:54 :: 13] > [user_task] = PS.get_user_tasks_for_groups([\"credit\"])\n[\n  %{\n    complete: false,\n    data: %{credit_score: 700, income: 100000, debt_amount: 20000},\n    function: nil,\n    name: :perform_pre_approval,\n    type: :user,\n    next: :route_on_pre_approval_completion,\n    __struct__: Mozart.Task.User,\n    uid: \"a987e7f0-15ba-422d-a26d-7ff6a6bdaaad\",\n    assigned_groups: [\"credit\"],\n    inputs: [:credit_score, :income, :debt_amount],\n    process_uid: \"5ece8627-623b-46f1-afa2-0fb11659a874\"\n  }\n]\n```\n\nLet's assume that is sufficient information for granting pre-approval. We can do this like so:\n\n```\n PS.complete_user_task(ppid, user_task.uid, %{pre_approval: true})\n\n```\n\nAt this point, the case task should have completed and routed the process to the user task **receive_mortgage_application**. The task will be completed when the loan applicant provides the bank with an mortgage application for a house that has been selected for purchase. The bank user will complete this task by entering the purchase price of the house.\n\nLet's do that now:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"credit\"])\nPS.complete_user_task(ppid, user_task.uid, %{purchase_price: 500_000})\n\n```\n\nWe have now accepted the customers loan application and noted that the purchase price is $500,000. We are ready to process the loan. Loan processsing is the bank's procedure to ensure that all of the information gathers thus far is in order. A user task for processing the loan should now be open. Let's check that it is:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"credit\"])\n\n```\n\nwhich produces:\n\n```\niex [18:16 :: 17] > [user_task] = PS.get_user_tasks_for_groups([\"credit\"])\n[\n  %{\n    complete: false,\n    data: %{\n      credit_score: 700,\n      income: 100000,\n      debt_amount: 20000,\n      purchase_price: 500000\n    },\n    function: nil,\n    name: :process_loan,\n    type: :user,\n    next: :process_loan_outcome,\n    __struct__: Mozart.Task.User,\n    uid: \"2aa15c30-b147-469d-b8a5-34946b2165df\",\n    assigned_groups: [\"credit\"],\n    inputs: [:purchase_price, :credit_score, :income, :debt_amount],\n    process_uid: \"8d106b1c-32f4-43b6-a168-e663bb59056f\"\n  }\n]\n```\n\nNow let's complete that task, asserting that the loan has been verified:\n\n```\nPS.complete_user_task(ppid, user_task.uid, %{loan_verified: true})\n\n```\n\nNow we are ready for the underwriting department to assess whether the loan should be approved. Let's query for the task and approve the loan:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"underwriting\"])\nPS.complete_user_task(ppid, user_task.uid, %{loan_approved: true})\n\n```\n\nWe are now ready for the final task of our process - informing the customer that the loan has been approved. Let's do that now:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"credit\"])\nPS.complete_user_task(ppid, user_task.uid, %{loan_approved: true})\n\n```\n\nAt this point, our logs should indicate that the process has finished, as indeed we do:\n\n```\niex [18:16 :: 23] > PS.complete_user_task(ppid, user_task.uid, %{loan_approved: true})\n:ok\n18:46:03.183 [info] Complete user task [communicate_approval][53a2b9ae-ba89-49f2-beba-0fdd8f49ab1f]\n18:46:03.183 [info] Process complete [home_loan_process][8d106b1c-32f4-43b6-a168-e663bb59056f]\n```\n\nNow let's start over at the beginning, and enter data so that the process completes with the loan being declined:\n\n```\nPS.clear_state()\nPS.load_process_model(model)\ndata = %{credit_score: 700, income: 100_000, debt_amount: 20_000}\n{:ok, ppid, _uid, _process_key} = PE.start_process(:home_loan_process, data)\nPE.execute(ppid)\n\n```\n\nNow, instead of granting pre-approval, let's decline the loan with the following:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"credit\"])\nPS.complete_user_task(ppid, user_task.uid, %{pre_approval: false})\n\n```\n\nWe see in the last log entry, that we have a new **communicate_loan_denied** task.\n\n```\niex [18:16 :: 32] > PS.complete_user_task(ppid, user_task.uid, %{pre_approval: false})\n:ok\n18:53:57.138 [info] New task instance [route_on_pre_approval_completion][645b421a-11ef-461e-91a7-7aa7e7fc66e6]\n18:53:57.138 [info] Complete user task [perform_pre_approval][3ee4b0d2-1432-4d54-b248-34ae928db983]\n18:53:57.138 [info] Complete case task [route_on_pre_approval_completion][645b421a-11ef-461e-91a7-7aa7e7fc66e6]\n18:53:57.139 [info] New task instance [communicate_loan_denied][a6a5bacd-a5a4-4b1e-a39b-99c0c8b58d04]\n```\n\nLet's complete that task now:\n\n```\n[user_task] = PS.get_user_tasks_for_groups([\"credit\"])\nPS.complete_user_task(ppid, user_task.uid, %{loan_approved: false})\n\n```","ref":"home_loan.html"},{"type":"extras","title":"Mozart Event Types","doc":"# Mozart Event Types\n\nCurrently, there is just one event type as described below. This document will be updated as addtional event types are implemented.","ref":"event_types.html"},{"type":"extras","title":"Task Exit Event - Mozart Event Types","doc":"A **Task Exit Event** allows a process execution to exit an open task in response to an external event (a Phoenix.PubSub event). When the task exits in this way, process execution will follow an alternate execution path as specified the the *task exit event*.\n\nThe *task exit event* is implemented by a struct with the following fields:\n\n* A **name** field with uniquely identifies the event within the scope of the containing process model.\n* Optionally, a **function** field can be used to alter the process data when the event is handled.\n* **message_selector** field requires a function specification used to select Phoenix.PubSub events.\n* The **exit_task** field specifies the name of the task that would exit in response to the event.\n* The **next** field specifies the name of the next task, if any, that should be opened in response to the event.\n* Finally, a **type** field that will default to  **:task_exit** for this event type.","ref":"event_types.html#task-exit-event"},{"type":"extras","title":"Task Exit Event Example - Mozart Event Types","doc":"If you are following along, open an Elixir project that has Mozart as a dependency.\n\n```\niex -S mix\n\n```\n\nNow paste the following alias' into your iex session\n\n```\n alias Mozart.Data.ProcessModel\n alias Mozart.ProcessEngine, as: PE\n alias Mozart.ProcessService, as: PS\n alias Mozart.Task.Service\n alias Mozart.Task.User\n alias Mozart.Task.Subprocess\n alias Mozart.Event.TaskExit\n alias Phoenix.PubSub\n\n```\n\nNow we define two process models - one top level model and one subprocess model. We specify a **TaskExit** event whose occurence will cause the subprocess to exit and a new service task to be opened.\n\nGo ahead and paste it into your iex session:\n\n```\nmodels = [\n      %ProcessModel{\n        name: :simple_call_process_model,\n        tasks: [\n          %Subprocess{\n            name: :call_process_task,\n            sub_process_model_name: :sub_process_with_one_user_task\n          },\n          %Service{\n            name: :service_after_task_exit,\n            function: fn data -> Map.put(data, :service_after_task_exit, true) end\n          }\n        ],\n        events: [\n          %TaskExit{\n            name: :exit_sub_process,\n            exit_task: :call_process_task,\n            message_selector: fn msg ->\n              case msg do\n                :exit_user_task -> true\n                _ -> nil\n              end\n            end,\n            next: :service_after_task_exit\n          }\n        ],\n        initial_task: :call_process_task\n      },\n    %ProcessModel{\n      name: :sub_process_with_one_user_task,\n      tasks: [\n        %User{\n          name: :user_task,\n          assigned_groups: [\"admin\"]\n        }\n      ],\n      initial_task: :user_task\n    }\n  ]\n\n```\n\nNow let's load the process models, and then start and execute the process top level process model:\n\n```\nPS.clear_state()\nPS.load_process_models(models)\ndata = %{}\n\n{:ok, ppid, _uid, process_key} = PE.start_process(:simple_call_process_model, data)\nPE.execute(ppid)\n\n```\n\nand we should see in our logs:\n\n```\n15:59:17.305 [info] Start process instance [simple_call_process_model][3a205a5b-07a3-4ecc-926e-0f405eddd0ac]\n{:ok, #PID<0.285.0>, \"3a205a5b-07a3-4ecc-926e-0f405eddd0ac\",\n \"272c2c9c-adcb-444d-a010-479aa68e6025\"}\niex [15:58 :: 14] > PE.execute(ppid)\n:ok\n15:59:17.308 [info] New task instance [call_process_task][7404314e-3590-459a-a71f-458a5416966a]\n15:59:17.308 [info] Start process instance [sub_process_with_one_user_task][cf66c2a2-75e9-4649-b4bd-070ca9e3746a]\n15:59:17.309 [info] New task instance [user_task][106e85b5-082a-47b9-ab66-4606617efc7e]\n```\n\nNotice that two processes have been started - the top level process we explicitly started, and a subprocess. Let's use the process key to examine the state of both processes:\n\n```\nPS.get_processes_for_process_key(process_key)\n\n```\n\nWe should see something like this:\n\n```\niex [15:58 :: 15] > PS.get_processes_for_process_key(process_key)\n[\n  %Mozart.Data.ProcessState{\n    uid: \"3a205a5b-07a3-4ecc-926e-0f405eddd0ac\",\n    process_key: \"272c2c9c-adcb-444d-a010-479aa68e6025\",\n    parent_pid: nil,\n    model_name: :simple_call_process_model,\n    start_time: ~U[2024-06-12 20:59:17.302851Z],\n    end_time: nil,\n    execute_duration: nil,\n    open_tasks: %{\n      \"7404314e-3590-459a-a71f-458a5416966a\" => %{\n        complete: false,\n        data: %{},\n        name: :call_process_task,\n        type: :sub_process,\n        next: nil,\n        __struct__: Mozart.Task.Subprocess,\n        uid: \"7404314e-3590-459a-a71f-458a5416966a\",\n        sub_process_model_name: :sub_process_with_one_user_task,\n        sub_process_pid: #PID<0.286.0>,\n        start_time: ~U[2024-06-12 20:59:17.308810Z],\n        finish_time: nil,\n        duration: nil,\n        process_uid: \"3a205a5b-07a3-4ecc-926e-0f405eddd0ac\"\n      }\n    },\n    completed_tasks: [],\n    data: %{},\n    complete: false\n  },\n  %Mozart.Data.ProcessState{\n    uid: \"cf66c2a2-75e9-4649-b4bd-070ca9e3746a\",\n    process_key: \"272c2c9c-adcb-444d-a010-479aa68e6025\",\n    parent_pid: #PID<0.285.0>,\n    model_name: :sub_process_with_one_user_task,\n    start_time: ~U[2024-06-12 20:59:17.308880Z],\n    end_time: nil,\n    execute_duration: nil,\n    open_tasks: %{\n      \"106e85b5-082a-47b9-ab66-4606617efc7e\" => %{\n        complete: false,\n        function: nil,\n        name: :user_task,\n        type: :user,\n        next: nil,\n        __struct__: Mozart.Task.User,\n        uid: \"106e85b5-082a-47b9-ab66-4606617efc7e\",\n        assigned_groups: [\"admin\"],\n        start_time: ~U[2024-06-12 20:59:17.309097Z],\n        finish_time: nil,\n        duration: nil,\n        inputs: nil,\n        process_uid: \"cf66c2a2-75e9-4649-b4bd-070ca9e3746a\"\n      }\n    },\n    completed_tasks: [],\n    data: %{},\n    complete: false\n  }\n]\n\n```\n\nAs we expected, we see that there are two processes, each having one open task. The high level process has an open subprocess task. The subprocess has a user task open.\n\nNow, we want to generate a task exit event on the open task in the high level process. In practice, this might be done using a send task in another process engine instance. For the purpose of our example, we will just broadcast a PubSub event as follows:\n\n```\n PubSub.broadcast(:pubsub, \"pe_topic\", {:event, :exit_user_task})\n\n```\n\nThis should result in the following output:\n\n```\niex [19:12 :: 17] > PubSub.broadcast(:pubsub, \"pe_topic\", {:event, :exit_user_task})\n:ok\n19:14:04.732 [info] Process complete due to task exit event [sub_process_with_one_user_task][97f945f1-b508-44ec-87ad-812d7dbb1a3d]\n19:14:04.732 [info] New task instance [service_after_task_exit][20e12b5f-dbe9-4d17-b008-57342963ac45]\n19:14:04.732 [info] Complete service task [service_after_task_exit[20e12b5f-dbe9-4d17-b008-57342963ac45]\n19:14:04.732 [info] Process complete [simple_call_process_model][059eccc4-a0f6-4f1a-8009-6fcf7b622e87]\n```\n\n* The first log statement tells us that the subprocess exited due to a task exit event.\n* The second log statement shows that a new service task was opened and it is the task specified in the **next** field of the **TaskExit** event.\n* The third log statement shows that the service task completed.\n* And, finally, the last log statement shows that out top level process completed.","ref":"event_types.html#task-exit-event-example"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}